/*
 * Flight_Data_Analyzer_Graph.java
 *
 * Created on January 3, 2005, 3:09 PM
 */

/**
 *
 * @author  swensonk
 */

import java.io.*;
import java.util.*;

public class Flight_Data_Analyzer_Graph extends javax.swing.JFrame {
   private static final int ciTIMER  = 0;
   private static final int ciTEMP   = 1;
   private static final int ciGFORCE = 2;
   private static final int ciPSIA   = 3;
   private static String strFile = null;
   
   public Flight_Data_Analyzer_Graph(String strFilename) {
      strFile = strFilename;
      initComponents();
      jlblTitle.setText(strFile);
      show();
   }
   
   /** This method is called from within the constructor to
    * initialize the form.
    * WARNING: Do NOT modify this code. The content of this method is
    * always regenerated by the Form Editor.
    */
   private void initComponents() {//GEN-BEGIN:initComponents
      jlblTitle = new javax.swing.JLabel();
      jbtnExit = new javax.swing.JButton();
      jcboxTimes10Mult = new javax.swing.JCheckBox();
      canvas = new javax.swing.JLabel();

      getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

      addWindowListener(new java.awt.event.WindowAdapter() {
         public void windowClosing(java.awt.event.WindowEvent evt) {
            exitForm(evt);
         }
      });

      jlblTitle.setText("Flight Data Recorder");
      getContentPane().add(jlblTitle, new org.netbeans.lib.awtextra.AbsoluteConstraints(144, 10, 580, 30));

      jbtnExit.setMnemonic('E');
      jbtnExit.setText("Exit");
      jbtnExit.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            jbtnExitActionPerformed(evt);
         }
      });

      getContentPane().add(jbtnExit, new org.netbeans.lib.awtextra.AbsoluteConstraints(730, 10, -1, -1));

      jcboxTimes10Mult.setText("Times 10 Multiplier");
      jcboxTimes10Mult.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            jcboxTimes10MultActionPerformed(evt);
         }
      });

      getContentPane().add(jcboxTimes10Mult, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, -1, -1));

      canvas.setMaximumSize(new java.awt.Dimension(1000, 600));
      canvas.setMinimumSize(new java.awt.Dimension(1000, 600));
      canvas.setPreferredSize(new java.awt.Dimension(1000, 600));
      canvas.setAutoscrolls(true);
      getContentPane().add(canvas, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 70, -1, 600));

      pack();
   }//GEN-END:initComponents

   private void jcboxTimes10MultActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jcboxTimes10MultActionPerformed
      // TODO add your handling code here:
      drawData();
   }//GEN-LAST:event_jcboxTimes10MultActionPerformed

   private void jbtnExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnExitActionPerformed
      // TODO add your handling code here:
      //System.exit(0);
      hide();
   }//GEN-LAST:event_jbtnExitActionPerformed
   
   /** Exit the Application */
   private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
      //System.exit(0);
      hide();
   }//GEN-LAST:event_exitForm
     
   // Variables declaration - do not modify//GEN-BEGIN:variables
   private javax.swing.JLabel canvas;
   private javax.swing.JButton jbtnExit;
   private javax.swing.JCheckBox jcboxTimes10Mult;
   private javax.swing.JLabel jlblTitle;
   // End of variables declaration//GEN-END:variables

   public void update(java.awt.Graphics g) { paint(g); }
   public void paint(java.awt.Graphics g)
   {  jbtnExit.repaint();
      jcboxTimes10Mult.repaint();
      jlblTitle.repaint();
      drawData();
   }
   
   //***********************************************************************************************************************//
   Vector[] aV = new Vector[4];
   //*** Read File into an Array[4] of Vectors ***//
   private Vector[] loadFile(String strFilename)
   {  //*** Test for Already Loaded (and Skip rest if so) ***//
      if ( aV[0] != null ) return aV;

      aV[ciTIMER]  = new Vector(0);
      aV[ciTEMP]   = new Vector(0);
      aV[ciGFORCE] = new Vector(0);
      aV[ciPSIA]   = new Vector(0);
      
      try
      {  //*** Open File ***/
         BufferedReader file = null;
         file = new BufferedReader(new FileReader(strFilename));
         //*** Read File into Vector[] ***/
         String sLine = null;
         boolean bIncludeTimer = false;
         int iTimer = 0;
         //*** Find Start of Data ***//
         while ( (sLine = file.readLine()) != null && sLine.toString().indexOf("---=[ Start of Data ]=---") < 0 )
            System.out.println("(Find Start of Data) sLine=" + sLine);            ;
         //*** Read First (Header) Line ***//
         if ( sLine != null ) sLine = file.readLine();
         System.out.println("(Header) sLine=" + sLine);
         //*** Test for Containing "Timer" ***//
         bIncludeTimer = (sLine.indexOf("Timer") != -1);
         iTimer = 0;
         while ( (sLine = file.readLine()) != null  && sLine.toString().indexOf("---=[ End of Data ]=---") < 0 )
         {  System.out.println("sLine=" + sLine);
            java.util.StringTokenizer st = new java.util.StringTokenizer(sLine,",");
            //*** Test File Includes "Temperature" Column AND static has more Tokens ***/
            if ( bIncludeTimer == true && st.hasMoreTokens() == true )
               //*** Add Timer from Data File ***//
               aV[ciTIMER].add(st.nextToken());
            else
               //*** Add Timer from Position Count ***//
               aV[ciTIMER].add(""+iTimer);
            //*** Test for Temperature Data and Add to Vector ***//
            if ( st.hasMoreTokens() == true )
               aV[ciTEMP].add(st.nextToken());
            //*** Test for GForce Data and Add to Vector ***//
            if ( st.hasMoreTokens() == true )
               aV[ciGFORCE].add(st.nextToken());
            //*** Test for PSIA Data and Add to Vector ***//
            if ( st.hasMoreTokens() == true )
               aV[ciPSIA].add(st.nextToken());
            iTimer++;
         }
         file.close();
      }
      catch(IOException e){System.out.println("loadFile:Exception=" + e.getMessage());System.out.flush();}
     
      //*** Trim to Size ***//
      aV[ciTIMER].trimToSize();
      aV[ciTEMP].trimToSize();
      aV[ciGFORCE].trimToSize();
      aV[ciTIMER].trimToSize();

      //*** Return Vector ***//
      return aV;
   }
   //***********************************************************************************************************************//
   private void drawData()
   {  //*** Load Data into Vector ***//
      final int iMAXX   = 1000;
      final int iMAXY   =  600;
      final int iOFFSET =  500;
      final int iMULTPLYER = (jcboxTimes10Mult.isSelected()==true)?10:1;
      final double dTIMERMULTIPLYER = 1.0;
      final double dTEMPMULTIPLYER = 5.0;
      final double dGFORCEMULTIPLYER = 100.0;
      final double dPSIAMULTIPLYER = 5.0;//0.25;
      final Vector[] aV = loadFile(strFile);
      java.awt.Image img = createImage(iMAXX,iMAXY);
      java.awt.Graphics imgg = img.getGraphics();
      
      //*** Draw Ticks every 0.1 Seconds for 1 Minute ***//
      imgg.setColor(java.awt.Color.LIGHT_GRAY);
      for ( int x = 0 ; x < iMAXX ; x++ )
      {  if ( (x % 10) == 0 )
            imgg.setColor(java.awt.Color.DARK_GRAY);
         else
            imgg.setColor(java.awt.Color.LIGHT_GRAY);
         imgg.drawLine(x*10,0,x*10,iMAXX);
      }
      //*** Draw Horizontal Ticks every 100 Units ***//
      imgg.setColor(java.awt.Color.LIGHT_GRAY);
      for ( int x = 0 ; x < iMAXX ; x+=100 )
      {  if ( x == iOFFSET )
            imgg.setColor(java.awt.Color.DARK_GRAY);
         else
            imgg.setColor(java.awt.Color.LIGHT_GRAY);
         imgg.drawLine(0,x,iMAXX,x);
      }
      
      int x = 1;
      while( x < aV[ciTEMP].size() )
      {  //*** Time ***//
         imgg.setColor(java.awt.Color.BLACK);
         imgg.drawLine((x-1)*iMULTPLYER,iOFFSET-(int)(Double.parseDouble(aV[ciTIMER].get(x-1).toString())*dTIMERMULTIPLYER),x*iMULTPLYER,iOFFSET-(int)(Double.parseDouble(aV[ciTIMER].get(x).toString())*dTIMERMULTIPLYER));
         //*** Temperature ***//
         imgg.setColor(java.awt.Color.RED);
         imgg.drawLine((x-1)*iMULTPLYER,iOFFSET-(int)(Double.parseDouble(aV[ciTEMP].get(x-1).toString())*dTEMPMULTIPLYER),x*iMULTPLYER,iOFFSET-(int)(Double.parseDouble(aV[ciTEMP].get(x).toString())*dTEMPMULTIPLYER));
         //*** GForce ***//
         imgg.setColor(java.awt.Color.BLUE);
         imgg.drawLine((x-1)*iMULTPLYER,iOFFSET-(int)(Double.parseDouble(aV[ciGFORCE].get(x-1).toString())*dGFORCEMULTIPLYER),x*iMULTPLYER,iOFFSET-(int)(Double.parseDouble(aV[ciGFORCE].get(x).toString())*dGFORCEMULTIPLYER));
         //*** PSIA ***//
         imgg.setColor(new java.awt.Color(0,127,0));
         imgg.drawLine((x-1)*iMULTPLYER,iOFFSET-(int)(Double.parseDouble(aV[ciPSIA].get(x-1).toString())*dPSIAMULTIPLYER),x*iMULTPLYER,iOFFSET-(int)(Double.parseDouble(aV[ciPSIA].get(x).toString())*dPSIAMULTIPLYER));
         x++;
      }
      //*** Legend ***//  
      imgg.setColor(java.awt.Color.RED);
      imgg.drawString("Temperature 0 - " + iOFFSET/dTEMPMULTIPLYER + " F",810,540);
      imgg.setColor(java.awt.Color.BLUE);
      imgg.drawString("Acceleration 0 - " + iOFFSET/dGFORCEMULTIPLYER + " G",810,560);
      imgg.setColor(new java.awt.Color(0,127,0));
      imgg.drawString("Altitude 0 - " + iOFFSET/dPSIAMULTIPLYER + " Feet",810,580);
      
      //*** Finally, Draw the Thing! ***//
      canvas.getGraphics().drawImage(img,1,1,iMAXX,iMAXY,null);
   }
}
